import { getToken } from '@/utils/auth.js'
import { MessageBox } from 'element-ui'
// 查询用户信息、token、提示登录状态与认证状态工具类
export class userAuth {
  constructor(to, from, next) {
    this.router = { to, from, next }
  }
  getInfo = () => {
    return new Promise((resolve, reject) => {
      console.log('getToken', getToken())
      if (!getToken()) {
        // this.MessageTipsForLogin()
        this.router.next({ path: '/login/index', query: { redirect: this.router.to.fullPath }})
        reject()
      } else {
        resolve()
      }
    })
  }
  MessageTipsForLogin = () => {
    MessageBox({
      title: '无法访问',
      message: `您需要<span style="color: red;cursor:default;">登录</span>以访问此服务`,
      type: 'warning',
      dangerouslyUseHTMLString: true,
      showClose: false,
      lockScroll: true,
      showCancelButton: true,
      confirmButtonText: '前往登录',
      cancelButtonText: '暂不登录',
      callback: (action) => {
        if (action === 'confirm') {
          this.router.next({ path: '/login/index', query: { redirect: this.router.to.fullPath }})
        } else {
          this.router.next({ path: this.$route.path })
        }
      }
    })
  }
}
// 路由拦截类
export class PageIntercept extends userAuth {
  // eslint-disable-next-line no-useless-constructor
  constructor(to, from, next) {
    super(to, from, next)
  }
  USER_VISITOR() {
    this.router.next() // 游客菜单直接跳转
  }
  USER_LOGIN() {
    this.getInfo().then(() => { // 登录菜单判断是否登录
      this.router.next()
    })
  }
}
