import Vue from 'vue'
import Router from 'vue-router'
import NProgress from 'nprogress' // progress bar
import 'nprogress/nprogress.css' // progress bar style
import { PageIntercept } from '@/router/USER_level'
import routes from '@/router/routes'

NProgress.configure({ showSpinner: false }) // NProgress Configuration
Vue.use(Router)
const createRouter = () => new Router({
  scrollBehavior: () => ({ y: 0 }),
  routes,
  mode: 'hash'
})
// const whiteList = ['/auth-redirect', '/bind', '/register', '/login', '/forgetPwd']
const router = createRouter()
router.beforeEach((to, from, next) => {
  if (to.meta.animation === false && from.meta.animation === false) {
    to.meta.needAnimation = false // 路由跳转过程中是否显示白屏动画
  } else {
    to.meta.needAnimation = true
  }
  new PageIntercept(to, from, next)[to.meta.USER_LEVEL || 'USER_VISITOR']()
})
router.afterEach(() => {
  // finish progress bar
  NProgress.done()
})
export default router
